unit XslFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, SHDocVw, DBClient, DB, DBTables, ComCtrls, mshtml_tlb,
  ActiveX, xmldom, XMLIntf, XSLProd, msxmldom, XMLDoc;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Table1: TTable;
    ClientDataSet1: TClientDataSet;
    WebBrowser1: TWebBrowser;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    WebBrowser2: TWebBrowser;
    Button2: TButton;
    XMLDoc: TXMLDocument;
    XSLPage: TXSLPageProducer;
    Memo1: TMemo;
    Button3: TButton;
    SaveDialog1: TSaveDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
if OpenDialog1.execute then
   WebBrowser1.Navigate(OpenDialog1.FileName);
   XmlDoc.FileName := OpenDialog1.FileName;
end;

procedure TForm1.Button2Click(Sender: TObject);
Var
  HtmlString : OleVariant;
  Doc : IhtmlDocument2;
  DocString : String;
begin
     WebBrowser2.Navigate('About:Blank');
     if OpenDialog1.Execute then
        begin
        XmlDoc.Active := True;
        XSLPage.FileName := OpenDialog1.FileName;
        DocString := XslPage.Content;
        Doc := WebBrowser2.Document as IhtmlDocument2;
        HTMLString := VarArrayCreate([0,0], varVariant);
        HtmlString[0] := DocString;
        Doc.write(PsafeArray(TvarData(HtmlString).Varray));
        //Doc.close;
        WebBrowser2.Visible := True;
        XmlDoc.Active := False;
        Memo1.Text := DocString;
        end;

end;

procedure TForm1.Button3Click(Sender: TObject);
Var
 DocString : String;
 F1 : textfile;
 Ch: Char;
 I : Integer;
begin
if OpenDialog1.Execute then
        begin
        XmlDoc.Active := True;
        XSLPage.FileName := OpenDialog1.FileName;
        DocString := XslPage.Content;
        end;
if SaveDialog1.Execute then
   begin
   AssignFile(F1, SaveDialog1.fileName);
   Rewrite(F1);
   WriteLn(F1,Docstring);
   {I := 0;
   while I <> Pred(Length(DocString)) do
      begin
      Ch := DocString[I];
      Write(F1, Ch);
      Inc(I);
      end;}
   CloseFile(F1);
   end;
WebBrowser2.Navigate(SaveDialog1.FileName);
Memo1.Text := DocString;
end;

end.
